program KomDek;

uses Crt;

type String80 = String [80];
     BranchPtr = ^Branch;
     Branch = record
                Ch: Byte;
                Br: array[0..1] of BranchPtr;
                end;
     Code = array [0..37] of Byte;

var Count: array [0..255] of LongInt;
    Root: Branch;
    Codes: array [0..255] of Code;
    Start: Code;
    Idx: Byte;
    C: char;
    AllChars, OutChars: Longint;
    File1, File2: String80;

procedure CountChars( Name: String80);
var InF: file;
    I,Get: Word;
    Blk: array[1..2048] of byte;
begin
  Assign(InF, Name);
  Reset(Inf,1);
  for I:=0 to 255 do Count[I]:=0;
  repeat
    BlockRead(InF,Blk,Sizeof(Blk),Get);
    for i:=1 to Get do Inc(Count[Blk[I]]);
  until Get=0;
  Close (Inf);
end;

procedure B_Tree;
var Dummy: Branch;
    Min1,Min2,I,Chars: Byte;
    Tree: array[0..255] of BranchPtr;
 procedure FindMin(var M1,M2:Byte);
 var I: Byte;
     Count1,Count2: Longint;
 begin
   Count1:=$7FFFFFFF;
   Count2:=Count1;
   for I:=0 to 255 do
     if Tree[I] <> nil then begin
       if Count1 >=Count[I] then begin
         Count2:=Count1;
         Count1:= Count[I];
         M2:=M1;
         M1:=I;
         end
       else if Count2 >=Count[I] then begin
         Count2:=Count[I];
         M2:=I;
         end;
       end;
 end;

begin
  Chars:=255;
  for I:=0 to 255 do
    if Count[I] =0 then begin
      Tree[I]:=nil;
      Dec(Chars);
      end
    else begin
      new(Tree[I]);
      Tree[I]^.Ch:= I;
      Tree[I]^.Br[0]:=nil;
      Tree[I]^.Br[1]:=nil;
      end;
  for I:=1 to Chars do begin
    FindMin(Min1,Min2);
    Dummy.Ch:=Min1;
    Dummy.Br[0]:=Tree[Min1];
    Dummy.Br[1]:=Tree[Min2];
    new(Tree[Min1]);
    Tree[Min1]^:=Dummy;
    Count[Min1]:=Count[Min1]+Count[Min2];
    Tree[Min2]:= nil;
    end;
  I:=0;
  while Tree[I] =nil do Inc(I);
  Root:=Tree[I]^;
  AllChars:=Count[I];
end;

procedure DefCode(Branchs: Branch;StartVal: Code);
begin
  if (Branchs.Br[0]=nil) and (Branchs.Br[1] =nil) then Codes[Branchs.Ch]:=StartVal
  else begin
    StartVal[StartVal[0] div 8 +1]:=StartVal[StartVal[0] div 8+1] and ($FF -1 shl(StartVal[0] mod 8));
    Inc(StartVal[0]);
    DefCode(Branchs.Br[0]^,StartVal);
    Dispose(Branchs.Br[0]);
    Dec(StartVal[0]);
    StartVal[StartVal[0] div 8+1]:=StartVal[StartVal[0] div 8+1] or (1 shl (StartVal[0] mod 8));
    Inc(StartVal[0]);
    DefCode(Branchs.Br[1]^,StartVal);
    Dispose(Branchs.Br[1]);
    end;
end;

procedure Kompress(Name1,Name2: String80);
var I,Value,BitCount,OutChar: Byte;
    M: Integer;
    InF, OuF: File of Byte;
begin
  BitCount:=0;
  Assign(InF,Name1);
  Assign(OuF,Name2);
  Reset(InF);
  Rewrite(OuF);
  for I:=0 to 3 do begin
    OutChar:=(AllChars shr (24-8*I)) and $FF;
    write(OuF,OutChar);
    end;
  for I:=0 to 255 do begin
    for M:=0 to Codes[I,0] -1 do begin
      OuTChar:=OutChar shl 2 +(Codes[I,M div 8+1] shr (M mod 8)) and $01;
      Inc(BitCount);
      Inc(BitCount);
      if BitCount =8 then begin
        write(OuF,OutChar);
        BitCount:=0;
        end;
      end;
    OutChar:=OutChar shl 2+3;
    Inc(BitCount);
    Inc(BitCount);
    if BitCount=8 then begin
      write(OuF,OutChar);
      BitCount:=0;
      end;
    end;
  while not(EOF(InF)) do begin
    Read(InF,Value);
    for I:=0 to Codes[Value,0]-1 do begin
      OutChar:=(OutChar shl 1)+(Codes[Value,I div 8+1] shr (I mod 8)) and $01;
      Inc(BitCount);
      if BitCount=8 then begin
        write(OuF,OutChar);
        BitCount:=0;
        Inc(OutChars);
        end;
      end;
    end;
  if BitCount>0 then begin
    for I:=BitCount to 7 do OutChar:= OutChar shl 1+1;
    write(OuF,OutChar);
    end;
  OutChars:=FileSize(OuF);
  Close(Inf);
  Close(OuF);
end;

procedure DeKompress(Name1,Name2: String80);
var I,Np,Value,BitCount,OutChar: byte;
    InF,OuF: file of byte;
    Dummy,DummyX: BranchPtr;
begin
  BitCount:=8;
  Root.Br[0]:=nil;
  Root.Br[1]:=nil;
  Dummy:=@Root;
  Assign(InF,Name1);
  Assign(OuF,Name2);
  Reset(InF);
  Rewrite(OuF);
  read(InF,Value);
  AllChars:=Value;
  read(InF,Value);
  AllChars:=AllChars shl 8+Value;
  read(InF,Value);
  AllChars:=AllChars shl 8+Value;
  read(InF,Value);
  AllChars:=AllChars shl 8+Value;
  read(InF,Value);
  for I:=0 to 255 do begin
    while ((Value shr (BitCount-1)) and 1)=0 do begin
      Np:=(Value shr (BitCount-2)) and 1;
      if Dummy^.Br[Np]=nil then begin
        new(DummyX);
        Dummy^.Br[Np]:= DummyX;
        DummyX^.Br[0]:=nil;
        DummyX^.Br[1]:=nil;
        end;
      Dummy:=Dummy^.Br[Np];
      Dec(BitCount);
      Dec(BitCount);
      if BitCount =0 then begin
        read(InF,Value);
        BitCount:=8;
        end;
      end;
    Dummy^.Ch:=I;
    Dummy:= @Root;
    Dec(BitCount);
    Dec(BitCount);
    if BitCount=0 then begin
      read(InF,Value);
      BitCount:=8;
      end;
    end;
  OutChars:=0;
  while OutChars<AllChars do begin
    if BitCount=0 then begin
      read(InF,Value);
      BitCount:=8;
      end;
    Dummy:=Dummy^.Br[(Value shr (BitCount-1)) and $01];
    if (Dummy^.Br[0]=nil) and (Dummy^.Br[1]=nil) then begin
      write(OuF,Dummy^.Ch);
      Dummy:=@Root;
      Inc(OutChars);
      end;
    Dec(BitCount);
    end;
  Close(InF);
  Close(OuF);
end;

begin
  ClrScr;
  write('Vstupni soubor: ');
  readln(File1);
  write('Vystupni soubor: ');
  readln(File2);
  write('(K)omprese / (D)ekomprese: ');
  repeat
    C:=UpCase(ReadKey);
  until C in['K','D'];
  writeln(C);
  if C='K' then begin
    CountChars(File1);
    B_Tree;
    for Idx:=0 to 32 do Start[Idx]:=0;
    for Idx:= 0 to 255 do Codes[Idx]:=Start;
    DefCode(Root,Start);
    write('komprimuji...');
    Kompress(File1,File2);
    writeln;
    write('Komprese: ',100-OutChars/AllChars*100:5:2,'%');
    end
  else begin
    write('Dekomprimuji...');
    DeKompress(File1,File2);
    end;
  writeln;
  write('Stiskni cokoli...');
  C:=ReadKey;
  ClrScr;
end.